"{ Package: 'stx:libjava/tools' }"

PPCompositeParserTest subclass:#JavaSourcePartitionerTests
	instanceVariableNames:'partitioner'
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Java-Tests-Parser'
!



!JavaSourcePartitionerTests methodsFor:'accessing'!

parserClass
        ^ JavaSourcePartitioner

    "Modified: / 11-01-2013 / 12:18:45 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !


!JavaSourcePartitionerTests methodsFor:'parsing'!

parse: aString rule: aSymbol
        | production |

        partitioner := production := self parserInstance.
        aSymbol = #start
                ifFalse: [ production := production productionAt: aSymbol ].
        result :=production parse: (JavaScanner for: aString).
        self
                deny: result isPetitFailure
                description: 'Unable to parse ' , aString printString
                resumable: true.
        ^ result

    "Created: / 11-01-2013 / 12:21:34 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !


!JavaSourcePartitionerTests methodsFor:'tests'!

test_01
    self parse: '
class X {
    public int foo() {
        return 10;
    }
}
    '

    "Created: / 11-01-2013 / 12:16:13 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !


!JavaSourcePartitionerTests class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/libjava/tools/JavaSourcePartitionerTests.st,v 1.2 2013-02-25 11:15:35 vrany Exp $'
!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

