"{ Package: 'stx:libjava/examples/tomcat6' }"

ApplicationDefinition subclass:#'stx_libjava_examples_tomcat6'
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!



!stx_libjava_examples_tomcat6 class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
    )
!

isGUIApplication
    "return true, if this is a GUI application.
     (these need more libraries and use a different startup procedure)"

    ^ false
!

preRequisites
    "list all required packages.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies and looking for
     global variable accesses. (the browser has a menu function for that)
     Howevery, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPrerequisites method."

    ^ #(
        #'stx:libbasic'    "ApplicationDefinition - superclass of stx_libjava_examples_tomcat6 "
        #'stx:libbasic2'    "UUID - referenced by ApacheTomcat6Start class>>applicationUUID "
        #'stx:libcomp'
        #'stx:libjava'
        #'stx:libview2'
    )
!

subProjects
    "list packages which are known as subprojects.
     This method is generated automatically; however, when generating automatically,
     packages are only added - never removed, unless listed in #excludedFromSubProjects."

    ^ #(
)
! !


!stx_libjava_examples_tomcat6 class methodsFor:'description - compilation'!

additionalRules_bc_dot_mak
    ^ '
ant:
        ant -f apache-tomcat-6.0.35-src\build.xml

'

    "Modified: / 11-01-2013 / 00:08:07 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

additionalRules_make_dot_proto
    ^ '
ant:
        ant -f apache-tomcat-6.0.35-src/build.xml


'

    "Modified: / 11-01-2013 / 00:08:21 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

additionalTargets_bc_dot_mak

    ^ 'ant'

    "Modified: / 11-01-2013 / 00:08:27 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

additionalTargets_make_dot_proto

    ^ 'ant'

    "Created: / 05-09-2006 / 16:05:12 / cg"
    "Modified: / 11-01-2013 / 00:08:31 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !


!stx_libjava_examples_tomcat6 class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        #'stx_libjava_examples_tomcat6'
        ApacheTomcat6
    )
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
    )
! !


!stx_libjava_examples_tomcat6 class methodsFor:'description - project information'!

applicationIconFileName
    "Return the name (without suffix) of an icon-file (the app's icon); will be included in the rc-resource file"

    ^ nil
    "/ ^ self applicationName
!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'Jan Vrany'

    "Modified: / 11-01-2013 / 00:10:00 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

description
    "Return a description string which will appear in vc.def / bc.def"

    ^ 'Apache Tomcat 6.x Controller'

    "Modified: / 11-01-2013 / 00:09:51 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Jan Vrany  2013'

    "Modified: / 11-01-2013 / 00:09:30 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

productInstallDirBaseName
    "Returns a default installDir which will appear in <app>.nsi.
     This is usually not the one you want to keep"

    ^ (self package asCollectionOfSubstringsSeparatedByAny:':/') last
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'Apache Tomcat 6.x Controller'

    "Modified: / 11-01-2013 / 00:09:09 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !


!stx_libjava_examples_tomcat6 class methodsFor:'description - startup'!

startupClassName
    "the class that starts the show in its startupSelector method"

    ^ 'ApacheTomcat6'

    "Modified: / 10-01-2013 / 22:38:08 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

startupSelector
    "the message that is sent to the startupClass to start the show"

    ^ #'start'
! !


!stx_libjava_examples_tomcat6 class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/libjava/examples/tomcat6/stx_libjava_examples_tomcat6.st,v 1.2 2013-02-25 11:15:32 vrany Exp $'
!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

